/* Copyright (c) 2006, NIF File Format Library and Tools
All rights reserved.  Please see niflib.h for license. */

//-----------------------------------NOTICE----------------------------------//
// Some of this file is automatically filled in by a Python script.  Only    //
// add custom code in the designated areas or it will be overwritten during  //
// the next update.                                                          //
//-----------------------------------NOTICE----------------------------------//

#ifndef _NIPSYSDATA_H_
#define _NIPSYSDATA_H_

//--BEGIN FILE HEAD CUSTOM CODE--//
//--END CUSTOM CODE--//

#include "NiRotatingParticlesData.h"

// Include structures
#include "../gen/ParticleDesc.h"
namespace Niflib {

class NiPSysData;
typedef Ref<NiPSysData> NiPSysDataRef;

/*! Particle system data. */
class NiPSysData : public NiRotatingParticlesData {
public:
	/*! Constructor */
	NIFLIB_API NiPSysData();

	/*! Destructor */
	NIFLIB_API virtual ~NiPSysData();

	/*!
	 * A constant value which uniquly identifies objects of this type.
	 */
	NIFLIB_API static const Type TYPE;

	/*!
	 * A factory function used during file reading to create an instance of this type of object.
	 * \return A pointer to a newly allocated instance of this type of object.
	 */
	NIFLIB_API static NiObject * Create();

	/*!
	 * Summarizes the information contained in this object in English.
	 * \param[in] verbose Determines whether or not detailed information about large areas of data will be printed out.
	 * \return A string containing a summary of the information within the object in English.  This is the function that Niflyze calls to generate its analysis, so the output is the same.
	 */
	NIFLIB_API virtual string asString( bool verbose = false ) const;

	/*!
	 * Used to determine the type of a particular instance of this object.
	 * \return The type constant for the actual type of the object.
	 */
	NIFLIB_API virtual const Type & GetType() const;

	//--BEGIN MISC CUSTOM CODE--//
	//--END CUSTOM CODE--//
protected:
	/*! Unknown. */
	vector<ParticleDesc > particleDescriptions;
	/*! Unknown. */
	bool hasUnknownFloats3;
	/*! Unknown. */
	vector<float > unknownFloats3;
	/*! Unknown. */
	unsigned short unknownShort1;
	/*! Unknown. */
	unsigned short unknownShort2;
	/*! Unknown, probably a boolean. */
	byte unknownByte2;
	/*! Unknown, probably a boolean. */
	byte hasVertexColors2;
	/*! Num bytes per */
	mutable unsigned int numVertexColors2;
	/*! Unknown */
	unsigned int unknownInt3;
	/*! Unknown */
	vector<Color4 > vertexColors;
	/*! Unknown */
	unsigned int unknownInt4;
	/*! Unknown */
	unsigned int unknownInt5;
	/*! Unknown */
	unsigned int unknownInt6;
	/*! Unknown */
	unsigned short unknownShort3;
	/*! Unknown */
	byte unknownByte4;
public:
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void Read( istream& in, list<unsigned int> & link_stack, const NifInfo & info );
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void Write( ostream& out, const map<NiObjectRef,unsigned int> & link_map, list<NiObject *> & missing_link_stack, const NifInfo & info ) const;
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void FixLinks( const map<unsigned int,NiObjectRef> & objects, list<unsigned int> & link_stack, list<NiObjectRef> & missing_link_stack, const NifInfo & info );
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual list<NiObjectRef> GetRefs() const;
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual list<NiObject *> GetPtrs() const;
};

//--BEGIN FILE FOOT CUSTOM CODE--//
//--END CUSTOM CODE--//

} //End Niflib namespace
#endif
